firmware Module Reference

Firmware Management More...

## Classes

interface | Firmware_2_0_1
| Firmware management methods More...
interface | FirmwareUpdateStatus
| Firmware update status interface. More...
struct | ImageInfo_1_0_1
| Firmware image information More...
struct | ImageStatus
| Image upload/download status. More...
struct | UpdateHistoryEntry
| Firmware update history entry TODO: implement CR# 45668 on next interface change add comment field based on firmware tag "char tag[64];" to improve firmware update history entries without rootfs images More...
struct | UpdateStatus
| Firmware update status More...

## Enumerations

enum | UpdateHistoryStatus { SUCCESSFUL, FAILED, INCOMPLETE }
| Firmware update history status More...
enum | ImageState { NONE, UPLOADING, UPLOAD_FAILED, DOWNLOADING, DOWNLOAD_FAILED, COMPLETE }
| Image upload/download state. More...
enum | UpdateFlags { CROSS_OEM, CROSS_HW, ALLOW_UNTRUSTED }
| Flags for startUpdate() method. More...

## Variables

valueobject | SystemStartupEvent
| Event: System startup finished.
valueobject | SystemShutdownEvent
| Event: System shutdown started.
valueobject | FirmwareValidationFailedEvent
| Event: Firmware validation failed.
valueobject | FirmwareUpdateEvent
| Event: Firmware update base event. More...
string | newVersion
| Firmware version the device is being upgraded to.
valueobject | FirmwareUpdateStartedEvent
| Event: Firmware update started.
valueobject | FirmwareUpdateCompletedEvent
| Event: Firmware updated successfully.
valueobject | FirmwareUpdateFailedEvent
| Event: Firmware update failed.

## Detailed Description

Firmware Management

## Enumeration Type Documentation

## ImageState

enum firmware::ImageState

Image upload/download state.

Enumerator
NONE | No firmware image has been uploaded/downloaded.
UPLOADING | A firmware image is currently being uploaded.
UPLOAD_FAILED | There was a problem uploading an image to the device.
DOWNLOADING | The device is downloading a firmware image from a URL.
DOWNLOAD_FAILED | There was a problem downloading the image from a URL.
COMPLETE | A complete image has been successfully uploaded/downloaded.

## UpdateFlags

enum firmware::UpdateFlags

Flags for startUpdate() method.

Enumerator
CROSS_OEM | Ignore version, product and OEM constraints.
CROSS_HW | Ignore hardware constraints.
ALLOW_UNTRUSTED | Allow untrusted firmwares.

## UpdateHistoryStatus

enum firmware::UpdateHistoryStatus

Firmware update history status

Enumerator
SUCCESSFUL | The update was successfully completed.
FAILED | The update failed.
INCOMPLETE | The update was not completed.

## Variable Documentation

## FirmwareUpdateEvent

valueobject firmware::FirmwareUpdateEvent

Event: Firmware update base event.

Firmware version the device is being upgraded from